org.eclipse.net4j.util.concurrent

## Class RoundRobinList<E>

- java.lang.Object
- - java.util.AbstractCollection<E>
  - - java.util.AbstractList<E>
    - - java.util.AbstractSequentialList<E>
      - - java.util.LinkedList<E>
        - - org.eclipse.net4j.util.concurrent.RoundRobinList<E>

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, java.lang.Iterable<E>, java.util.Collection<E>, java.util.Deque<E>, java.util.List<E>, java.util.Queue<E>

      public final class RoundRobinList<E>
      extends java.util.LinkedList<E>

  Author:
    Eike Stepper
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class java.util.AbstractList

      `modCount`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RoundRobinList()`
    `RoundRobinList(java.util.Collection<? extends E> c)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `add(E o)`
    `void` | `add(int index, E element)`
    `boolean` | `addAll(java.util.Collection<? extends E> c)`
    `boolean` | `addAll(int index, java.util.Collection<? extends E> c)`
    `void` | `addFirst(E o)`
    `void` | `addLast(E o)`
    `void` | `clear()`
    `java.lang.Object` | `clone()`
    `boolean` | `contains(java.lang.Object o)`
    `boolean` | `containsAll(java.util.Collection<?> c)`
    `E` | `element()`
    `void` | `executeReads(java.lang.Runnable runnable)`
    `void` | `executeWrites(java.lang.Runnable runnable)`
    `E` | `get(int index)`
    `E` | `getFirst()`
    `E` | `getLast()`
    `int` | `indexOf(java.lang.Object o)`
    `int` | `lastIndexOf(java.lang.Object o)`
    `boolean` | `offer(E o)`
    `E` | `peek()`
    `E` | `poll()`
    `E` | `remove()`
    `E` | `remove(int index)`
    `boolean` | `remove(java.lang.Object o)`
    `boolean` | `removeAll(java.util.Collection<?> c)`
    `E` | `removeFirst()`
    `E` | `removeLast()`
    `boolean` | `retainAll(java.util.Collection<?> c)`
    `E` | `set(int index, E element)`
    `java.util.List<E>` | `subList(int fromIndex, int toIndex)`
    `java.lang.Object[]` | `toArray()`
    `<T> T[]` | `toArray(T[] a)`

    - ### Methods inherited from class java.util.LinkedList

      `descendingIterator, listIterator, offerFirst, offerLast, peekFirst, peekLast, pollFirst, pollLast, pop, push, removeFirstOccurrence, removeLastOccurrence, size, spliterator`

    - ### Methods inherited from class java.util.AbstractSequentialList

      `iterator`

    - ### Methods inherited from class java.util.AbstractList

      `equals, hashCode, listIterator, removeRange`

    - ### Methods inherited from class java.util.AbstractCollection

      `isEmpty, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.List

      `equals, hashCode, isEmpty, iterator, listIterator, replaceAll, sort`

    - ### Methods inherited from interface java.util.Deque

      `iterator`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, removeIf, stream`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

- - ### Constructor Detail

    - #### RoundRobinList

          public RoundRobinList()

    - #### RoundRobinList

          public RoundRobinList(java.util.Collection<? extends E> c)

  - ### Method Detail

    - #### executeReads

          public void executeReads(java.lang.Runnable runnable)

    - #### executeWrites

          public void executeWrites(java.lang.Runnable runnable)

    - #### add

          public void add(int index,
                          E element)

      Specified by:
        `add` in interface `java.util.List<E>`
      Overrides:
        `add` in class `java.util.LinkedList<E>`

    - #### add

          public boolean add(E o)

      Specified by:
        `add` in interface `java.util.Collection<E>`
      Specified by:
        `add` in interface `java.util.Deque<E>`
      Specified by:
        `add` in interface `java.util.List<E>`
      Specified by:
        `add` in interface `java.util.Queue<E>`
      Overrides:
        `add` in class `java.util.LinkedList<E>`

    - #### addAll

          public boolean addAll(java.util.Collection<? extends E> c)

      Specified by:
        `addAll` in interface `java.util.Collection<E>`
      Specified by:
        `addAll` in interface `java.util.List<E>`
      Overrides:
        `addAll` in class `java.util.LinkedList<E>`

    - #### addAll

          public boolean addAll(int index,
                                java.util.Collection<? extends E> c)

      Specified by:
        `addAll` in interface `java.util.List<E>`
      Overrides:
        `addAll` in class `java.util.LinkedList<E>`

    - #### addFirst

          public void addFirst(E o)

      Specified by:
        `addFirst` in interface `java.util.Deque<E>`
      Overrides:
        `addFirst` in class `java.util.LinkedList<E>`

    - #### addLast

          public void addLast(E o)

      Specified by:
        `addLast` in interface `java.util.Deque<E>`
      Overrides:
        `addLast` in class `java.util.LinkedList<E>`

    - #### clear

          public void clear()

      Specified by:
        `clear` in interface `java.util.Collection<E>`
      Specified by:
        `clear` in interface `java.util.List<E>`
      Overrides:
        `clear` in class `java.util.LinkedList<E>`

    - #### clone

          public java.lang.Object clone()

      Overrides:
        `clone` in class `java.util.LinkedList<E>`

    - #### contains

          public boolean contains(java.lang.Object o)

      Specified by:
        `contains` in interface `java.util.Collection<E>`
      Specified by:
        `contains` in interface `java.util.Deque<E>`
      Specified by:
        `contains` in interface `java.util.List<E>`
      Overrides:
        `contains` in class `java.util.LinkedList<E>`

    - #### containsAll

          public boolean containsAll(java.util.Collection<?> c)

      Specified by:
        `containsAll` in interface `java.util.Collection<E>`
      Specified by:
        `containsAll` in interface `java.util.List<E>`
      Overrides:
        `containsAll` in class `java.util.AbstractCollection<E>`

    - #### element

          public E element()

      Specified by:
        `element` in interface `java.util.Deque<E>`
      Specified by:
        `element` in interface `java.util.Queue<E>`
      Overrides:
        `element` in class `java.util.LinkedList<E>`

    - #### get

          public E get(int index)

      Specified by:
        `get` in interface `java.util.List<E>`
      Overrides:
        `get` in class `java.util.LinkedList<E>`

    - #### getFirst

          public E getFirst()

      Specified by:
        `getFirst` in interface `java.util.Deque<E>`
      Overrides:
        `getFirst` in class `java.util.LinkedList<E>`

    - #### getLast

          public E getLast()

      Specified by:
        `getLast` in interface `java.util.Deque<E>`
      Overrides:
        `getLast` in class `java.util.LinkedList<E>`

    - #### indexOf

          public int indexOf(java.lang.Object o)

      Specified by:
        `indexOf` in interface `java.util.List<E>`
      Overrides:
        `indexOf` in class `java.util.LinkedList<E>`

    - #### lastIndexOf

          public int lastIndexOf(java.lang.Object o)

      Specified by:
        `lastIndexOf` in interface `java.util.List<E>`
      Overrides:
        `lastIndexOf` in class `java.util.LinkedList<E>`

    - #### offer

          public boolean offer(E o)

      Specified by:
        `offer` in interface `java.util.Deque<E>`
      Specified by:
        `offer` in interface `java.util.Queue<E>`
      Overrides:
        `offer` in class `java.util.LinkedList<E>`

    - #### peek

          public E peek()

      Specified by:
        `peek` in interface `java.util.Deque<E>`
      Specified by:
        `peek` in interface `java.util.Queue<E>`
      Overrides:
        `peek` in class `java.util.LinkedList<E>`

    - #### poll

          public E poll()

      Specified by:
        `poll` in interface `java.util.Deque<E>`
      Specified by:
        `poll` in interface `java.util.Queue<E>`
      Overrides:
        `poll` in class `java.util.LinkedList<E>`

    - #### remove

          public E remove()

      Specified by:
        `remove` in interface `java.util.Deque<E>`
      Specified by:
        `remove` in interface `java.util.Queue<E>`
      Overrides:
        `remove` in class `java.util.LinkedList<E>`

    - #### remove

          public E remove(int index)

      Specified by:
        `remove` in interface `java.util.List<E>`
      Overrides:
        `remove` in class `java.util.LinkedList<E>`

    - #### remove

          public boolean remove(java.lang.Object o)

      Specified by:
        `remove` in interface `java.util.Collection<E>`
      Specified by:
        `remove` in interface `java.util.Deque<E>`
      Specified by:
        `remove` in interface `java.util.List<E>`
      Overrides:
        `remove` in class `java.util.LinkedList<E>`

    - #### removeAll

          public boolean removeAll(java.util.Collection<?> c)

      Specified by:
        `removeAll` in interface `java.util.Collection<E>`
      Specified by:
        `removeAll` in interface `java.util.List<E>`
      Overrides:
        `removeAll` in class `java.util.AbstractCollection<E>`

    - #### removeFirst

          public E removeFirst()

      Specified by:
        `removeFirst` in interface `java.util.Deque<E>`
      Overrides:
        `removeFirst` in class `java.util.LinkedList<E>`

    - #### removeLast

          public E removeLast()

      Specified by:
        `removeLast` in interface `java.util.Deque<E>`
      Overrides:
        `removeLast` in class `java.util.LinkedList<E>`

    - #### retainAll

          public boolean retainAll(java.util.Collection<?> c)

      Specified by:
        `retainAll` in interface `java.util.Collection<E>`
      Specified by:
        `retainAll` in interface `java.util.List<E>`
      Overrides:
        `retainAll` in class `java.util.AbstractCollection<E>`

    - #### set

          public E set(int index,
                       E element)

      Specified by:
        `set` in interface `java.util.List<E>`
      Overrides:
        `set` in class `java.util.LinkedList<E>`

    - #### subList

          public java.util.List<E> subList(int fromIndex,
                                           int toIndex)

      Specified by:
        `subList` in interface `java.util.List<E>`
      Overrides:
        `subList` in class `java.util.AbstractList<E>`

    - #### toArray

          public java.lang.Object[] toArray()

      Specified by:
        `toArray` in interface `java.util.Collection<E>`
      Specified by:
        `toArray` in interface `java.util.List<E>`
      Overrides:
        `toArray` in class `java.util.LinkedList<E>`

    - #### toArray

          public <T> T[] toArray(T[] a)

      Specified by:
        `toArray` in interface `java.util.Collection<E>`
      Specified by:
        `toArray` in interface `java.util.List<E>`
      Overrides:
        `toArray` in class `java.util.LinkedList<E>`

Copyright (c) 2004-2019 Eike Stepper (Loehne, Germany) and others.
All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0 which accompanies this distribution, and is available at http://www.eclipse.org/legal/epl-v10.html